/*
	Copyright (C) 2011 Steve Thomas <steve AT tobtu DOT com>

	This file is part of MySQL323 Collider.

	MySQL323 Collider is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MySQL323 Collider is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MySQL323 Collider.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KEY_SPACE_H
#define KEY_SPACE_H

#include "common.h"
#include <list>
#include <string>

using namespace std;

struct perCharCharSet
{
	char **charSets;
	uint32_t pwLength;
};

class KeySpace
{
public:
	KeySpace(const KeySpace &ks);
	KeySpace(const char *fileName);
	KeySpace(list<list<string> > subKeySpaces);
	KeySpace(perCharCharSet *subKeySpaces, uint32_t numSubKeySpaces);
	virtual ~KeySpace();

	KeySpace& operator=(const KeySpace &ks);

//	bool reset(uint64_t pwNum);
//	uint32_t next(vector4 *pw, uint32_t numPws, uint32_t vecSize);
//	uint32_t next(vector4 *pw, uint32_t numPws, uint32_t vecSize, uint32_t *diffs);
	uint64_t getKeySpace();
	uint32_t getMaxPwLen();

protected:
//	bool cycleCache();
//	bool cycleCache(uint32_t cachePos);
	void init(list<list<string> > subKeySpaces);
	void cleanUpKeySpace();
	void copyObject(const KeySpace &ks);

	uint64_t m_keySpace;
	uint64_t *m_keySpaceBoundaries;
	uint32_t *m_passwordLengths, *m_divShortCut/*, *m_charSetPoses*/, **m_charSetLengths/*, *m_charSetCacheLengths*/;
	int *m_numShortCutChars;
/*	uint16_t **m_charSetCache;*/
	char *m_charSet, ***m_subKeySpaces;
	uint32_t m_numSubKeySpaces/*, m_cachePos, m_curSubKeySpace, m_pw[4]*/, m_maxPwLen;
};

#endif
